<template lang="pug">
  div(class="blog-list__search-form")
    div
      div
        IconMagnifyingGlass(class="blog-list__search-form__icon-search")/
        input(
          type="search"
          :aria-label="$t('label.search.document')"
          :placeholder="$t('label.search.document')"
          v-model="query"
        )/
      ul(v-if="articles.length" class="blog-list__search-form-results")
        li(v-for="article of articles" :key="article.title")
          nuxt-link(:to="article.path" class="flex justify-between")
            div {{ article.title }}
            div {{ $moment(article.createdAt).fromNow() }}
</template>

<script>
import IconMagnifyingGlass from '~/assets/svg/ph-magnifying-glass-fill.svg?inline';

export default {
  name:       "BlogSearch",
  components: {
    IconMagnifyingGlass,
  },
  data() {
    return {
      query:    '',
      articles: []
    }
  },
  watch: {
    async query(query) {
      if (!query) {
        this.articles = []
        return
      }

      this.articles = await this.$content(this.$i18n.locale, {deep: true})
          .only(
              [
                'title',
                'slug',
                'path',
                'createdAt',
                'tags',
                'isDraft',
              ]
          )
          .sortBy('createdAt', 'asc')
          .where(
              {
                isDraft: {$eq: false}
              }
          )
          .limit(12)
          .search(query)
          .fetch()
      ;
    }
  }
}
</script>

<style lang="scss" scoped>
.blog-list {
  &__search-form {
    @apply md:col-span-2 lg:col-span-3 xl:col-span-4;

    &__icon {
      &-search {
        @apply
        absolute
        left-3
        top-1/2
        transform
        -translate-y-1/2
        text-gray-400
        dark:text-gray-500
        focus:text-gray-700
        fill-current
        w-4
        h-4
        ;
      }
    }

    > div {
      @apply
      w-full
      text-sm
      text-gray-700
      dark:text-gray-400
      focus:ring-1
      focus:ring-gray-500
      border
      border-gray-200
      dark:border-gray-600
      rounded-md
      shadow-md
      bg-gray-100
      dark:bg-gray-600
      ;

      > div {
        @apply relative;

        input {
          @apply
          focus:outline-none
          placeholder-gray-400
          dark:placeholder-gray-500
          bg-transparent
          w-full
          py-2
          pl-10
          ;
        }
      }
    }

    ul {
      @apply
      pl-10
      pr-2
      pb-2
      ;

      li {
        @apply
        relative
        w-full
        border-b
        border-gray-200
        dark:border-gray-700
        mt-2
        mb-2
        mr-2
        ml-0
        p-2
        ;

        &:hover {
          @apply
          bg-gray-500
          text-gray-100
          rounded-md
          border-b-0
          ;
        }

        &:last-child {
          @apply
          mb-0
          border-b-0
          ;
        }

        a {
          div:last-child {
            @apply
            hidden
            lg:block
            ml-4
            text-gray-300
            dark:text-gray-700
            ;
          }
        }
      }
    }
  }
}
</style>
